<?php
namespace HCM\FPA\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;

class CalculoFolhaRepository {
    
    protected  $connection;
    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }
    
    
    public function retornaCalculoFolha($nrorg, $nrtipomovimento, $nrTpModalidadeCalc, $nrOcorrenciaCalc,$dtOcorrencia){
        
        $params = array('nrorg'=>$nrorg, 'nrtipomoviment'=>$nrtipomovimento, 'nrtpmodalidcal'=>$nrTpModalidadeCalc,
        'nrocorrecal'=>$nrOcorrenciaCalc, 'dtinicial'=>$dtOcorrencia, 'dtfinal'=>$dtOcorrencia);
        $fpacalculofolha = Repositories::FPA_CALCULOFOLHA;
        
$sql = <<<SQL
SELECT c FROM $fpacalculofolha c
WHERE c.nrorg           = :nrorg
  AND c.nrtipomoviment = :nrtipomoviment
  AND c.nrtpmodalidcal      = :nrtpmodalidcal
  AND c.nrocorrecal      = :nrocorrecal
  AND (c.dtocorrencia between :dtinicial and :dtfinal)
SQL;

        $result = $this->entityManager->createQuery($sql)->execute($params);
        return $result;
    }
    
    public function retornaCalculoFolhaTodasOcorrencias($nrorg, $nrTipoMovimento, $nrTpModalidadeCalc, $dtInicial, $dtFinal){
        $params = array('nrorg'=>$nrorg, 'nrtipomoviment'=>$nrTipoMovimento, 'nrtpmodalidcal'=>$nrTpModalidadeCalc,
        'dtinicial'=>$dtInicial, 'dtfinal'=>$dtFinal);
        $fpacalculofolha = Repositories::FPA_CALCULOFOLHA;
        
$sql = <<<SQL
SELECT c FROM $fpacalculofolha c
WHERE c.nrorg           = :nrorg
  AND c.nrtipomoviment = :nrtipomoviment
  AND c.nrtpmodalidcal      = :nrtpmodalidcal
  AND c.nrocorrecal > 0
  AND (c.dtocorrencia between :dtinicial and :dtfinal)
SQL;

        $result = $this->entityManager->createQuery($sql)->execute($params);
        return $result;
    }
} 
