<?php

namespace HCM\Geral\Entity;

use HCM\Util\TkEntity;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\FPA\Entity\FpatipoassoceveEntity;
use Teknisa\Model\Gestaopessoas\Repositories\GpeVinculoh;
class GpevinculohEntity extends TkEntity
{

    const IDMULTVINC_UNICO = 'UNICO';
    const IDMULTVINC_PRIMARIO = 'PRIMARIO';
    const IDMULTVINC_SECUNDARIO = 'SECUNDARIO';
	const VINCULO_EMPREGATICIO_MENOR_APRENDIZ = '9';
    const TIPO_VINCULO_ESTAGIARIO = '2';
	const PERCENTUAL_FGTS_MENOR_APRENDIZ = '2';
	const IDCONTRIBUISIND_DESCONTOU = 'DESCONTOU';
    const IDCONTRIBUISIND_SEMPRE = 'SEMPRE';
    const IDCONTRIBUISIND_NUNCA = 'NUNCA';
    const IDMULTVINC_NAO = 'N';
    const IDMULTVINC_SIM = 'S';
    const IDTPPAGAMENTO_MENSAL = 'MENSAL';
    const IDTPPAGAMENTO_QUINZENAL = 'QUINZENAL';
    const IDTPPAGAMENTO_MENSAL_SALARIO_HORA = 'MENSAL_SALARIO_HORA';
    const IDTPPAGAMENTO_SEMANAL = 'SEMANAL';
    const IDTPPAGAMENTO_DIARIO = 'DIARIO';
    const IDREMUNERACAO_SAL1 = 'SAL1';
    const IDREMUNERACAO_SAL1_RSR = 'SAL1_RSR';
    const IDREMUNERACAO_SAL2 = 'SAL2';
    const IDREMUNERACAO_SAL2_RSR = 'SAL2_RSR';
    const IDREMUNERACAO_ESTAGIO = 'ESTAGIO';
    const IDREMUNERACAO_SOCIO = 'SOCIO';
    const IDREMUNERACAO_AUTONOMO = 'AUTONOMO';
    const IDREMUNERACAO_NENHUM = 'NENHUM';
    
    private $movimentacoes;
    
    
    public function __construct($entityManager, $hcmParameters){
        
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
        parent::__construct(null,$entityManager);
    }
    

    public function retornaVinculoHistoricoMesCompetencia($nrorg, $nr_vinculom, $mes_competencia){
        return $this->entityManager->getRepository(Repositories::GPE_VINCULOH)->retornaUltimoHistoricoCompetencia($nrorg, $nr_vinculom, $mes_competencia);
    }
    
    private function _retornaHistoricoAtual($nrOrg, $nrVinculom, TkDateTime $mesCompetencia){
        return Gpevinculoh::retornaHistoricoAtual($nrOrg, $nrVinculom, $mesCompetencia);
    }

    public function retornaHistoricos($nrorg, $nr_vinculom){
        return Gpevinculoh::retornaHistoricos($nrorg, $nr_vinculom);
    }

    public function adicionaPersisteHistorico(TkDateTime $mesCompetencia) {

        $dtVinculo = new TkDateTime($this->getDtmescompetenc(), TkDateTime::FORMAT_DATE);
        if ($mesCompetencia->equals($dtVinculo) === false) {

            $vinculoh = new self();
            $vinculoh->copyEntity($this);
            $vinculoh->setNrvinculoh(null);
            $vinculoh->setDtmescompetenc($mesCompetencia);

            $this->addItem($vinculoh);
        }

        $this->persist();
    }

    public function atualizaDataBaseFerias($nova_data_base) {
        $this->setDtbaseferias($nova_data_base);
    }

    public function atualizaNrDependentesImpostoRenda($nr_dependentes) {
        $this->setNrdependir($nr_dependentes);
    }

    public function atualizaNrDependentesSalarioFamilia($nr_dependentes) {
        $this->setNrdependsfam($nr_dependentes);
    }

    public function incluiVinculoH(
        $nrOrg, $nrVinculom, $nrEscalaTrabm, $nrSituFuncm, $dtVigencia, $contribuicaoSindical,
        $dtBaseFerias, $nrTpModalidade, $extra = array()
    ){

        $vinculoH = new self();
        $vinculoH->setNrorg($nrOrg);
        $vinculoH->setNrvinculom($nrVinculom);
        $vinculoH->setDtmescompetenc($dtVigencia);

        $vinculoH->setNrescalatrabm($nrEscalaTrabm);
        $vinculoH->setNrsitufuncm($nrSituFuncm);

        $vinculoH->setNrtpmodalidsal($nrTpModalidade);
        $vinculoH->setIdcontribuisind($contribuicaoSindical);
        $vinculoH->setDtbaseferias($dtBaseFerias);

        foreach ($extra as $dado_nome => $dado_valor) {
            $nome_metodo_get = 'get'.(ucfirst(strtolower($dado_nome)));
            $nome_metodo_set = 'set'.(ucfirst(strtolower($dado_nome)));
            if (method_exists($vinculoH, $nome_metodo_set) === true) {
                if (!$vinculoH->$nome_metodo_get())
                    $vinculoH->$nome_metodo_set($dado_valor);
            }
        }
        $vinculoH->persist();

        unset($vinculoH);
    }

    private function _procuraVinculoH($nrOrg, TkDateTime $mesCompetencia, $nrVinculom){

        $itens = $this->getItems();
        if (empty($itens) === true) {
            $this->_inicializaLista($nrOrg, $nrVinculom, $mesCompetencia);
            $itens = $this->getItems();
        }

        foreach ($itens as $posicao => $item) {
            if ($mesCompetencia->equals($item->getDtmescompetenc(), TkDateTime::FORMAT_DATE) === true) {
                return $posicao;
            }
        }

        return;

    }

    public function carregaVinculosHistoricos($nrOrg, $nrVinculom){
        $itens = $this->getItems();

        if (count($itens) === 0) {
            $objVinculoH = $this->retornaHistoricos($nrOrg, $nrVinculom);
            foreach ($objVinculoH as $item) {
                $this->addItem($item);
            }
        }

    }

    public function apagaVinculosHistoricos(){
        $itens = $this->getItems();
        foreach ($itens as $item) {
            $this->removeItem($item);
        }
    }

    private function _inicializaLista($nrOrg, $nrVinculom, TkDateTime $mesCompetencia){
        $vinculos = $this->_retornaHistoricoAtual($nrOrg, $nrVinculom, $mesCompetencia);
        foreach ($vinculos as $vinculo) {
            $this->addItem($vinculo);
        }
    }

    public function alteraSalarioVinculo(TkDateTime $mes_competencia, $salario){

        $vinculos = $this->getItems();
        if (empty($vinculos) === true) {
            $this->_inicializaLista($this->getNrorg(), $this->getNrvinculom(), $mes_competencia);
        }
        
        $posicao = $this->_procuraVinculoH($this->getNrvinculom(), $mes_competencia);
        if ($posicao !== false) {
            $vinculo = $this->getItem($posicao);
        } else {
            $vinculo = null;
        }

        if ($vinculo !== null) {
            $vinculo->setVrsalariovinc(round($salario, 2));
            $vinculo->setDtultatu(now());
        } else {
            $vinculo = new self();

            $vinculo->copy($this);
            $vinculo->setVrsalariovinc(round($salario, 2));
            $vinculo->setDtinclusao(now());
            $vinculo->setDtultatu(now());
            $vinculo->setDtmescompetenc($mes_competencia);
            $vinculo->setNrvinculoh(rand(1, 10000));
            $this->addItem($vinculo);
        }
    }

    public function converteValorSalarioParaMensal($ambiente_salario_operador, $jornada_diaria){

        /*
          if ($ambiente_salario_operador === GpeparamoperEntity::IDSALARIOOPER_REAL) {
            $salario = $this->getVrsalariovinc();
            $id_tipo_salario = $this->getIdtpsalariovinc();
        } else {
            $salario = $this->getVrsalacenario();
            $id_tipo_salario = $this->getIdtpsalacenario();
        }

        switch ($id_tipo_salario){
        case self::IDTPSALARIOVINC_HORA:
            $salario = $salario * $jornada_diaria * 30; break;
        case self::IDTPSALARIOVINC_DIARIO:
            $salario = $salario * 30; break;
        case self::IDTPSALARIOVINC_QUINZENAL:
            $salario = (($salario / 15) * 30); break;
        case self::IDTPSALARIOVINC_SEMANAL:
            $salario = (($salario / 7) * 30); break;
        }

        return $salario;
        */
    }

    public function converteValorSalarioParaHora($ambiente_salario_operador, $jornada_diaria){

        /*     if ($ambiente_salario_operador === GpeparamoperEntity::IDSALARIOOPER_REAL) {
            $salario = $this->getVrsalariovinc();
            $id_tipo_salario = $this->getIdtpsalariovinc();
        } else {
            $salario = $this->getVrsalacenario();
            $id_tipo_salario = $this->getIdtpsalacenario();
        }

        switch ($id_tipo_salario){
        case self::IDTPSALARIOVINC_DIARIO:
            $salario = $salario / $jornada_diaria; break;
        case self::IDTPSALARIOVINC_QUINZENAL:
            $salario = (($salario / 15) / $jornada_diaria); break;
        case self::IDTPSALARIOVINC_SEMANAL:
            $salario = (($salario / 7) / $jornada_diaria); break;
        case self::IDTPSALARIOVINC_MENSAL:
            $salario = (($salario / 30) / $jornada_diaria); break;
        }

        return $salario;
        */
    }


    public function getUltimoVinculoHistorico($nrOrg, $mesCompetencia, $nrVinculo){
        if (count($this->getItems()) === 0 ){
            $this->_inicializaLista($nrOrg, $nrVinculo, $mesCompetencia);
        }
        return end($this->getItems());
    }

    public function getVinculoHistorico($nrOrg, TkDateTime $mesCompetencia, $nrVinculom){

        $posicao = $this->_procuraVinculoH($nrOrg, $mesCompetencia, $nrVinculom);
        if (($posicao !== false) && ($posicao !== null)) {
            $vinculoh = $this->getItem($posicao);

        } else {
            $vinculo = $this->getUltimoVinculoHistorico($nrOrg, $mesCompetencia, $nrVinculom);
            $vinculoh = new self();
            $vinculoh->copy($vinculo);
        }

        return $vinculoh;
    }

    
    public function atualizaEscalaVinculoHistoricoPorAlteracao($nrOrg, TkDateTime $mesCompetencia, $nrVinculom, $nrEscala){
        $vinculoh = $this->getVinculoHistorico($nrOrg, $mesCompetencia, $nrVinculom);
        $vinculoh->setNrescalatrabm($nrEscala);
        $vinculoh->persist();
    }


    public function atualizaSituacaoFuncionalVinculoHistoricoPorAlteracao($nrOrg, TkDateTime $mesCompetencia, $nrVinculom, $nrSituacao){
        $vinculoh = $this->getVinculoHistorico($nrOrg, $mesCompetencia, $nrVinculom);
        $vinculoh->setNrsitufuncm($nrSituacao);
        $vinculoh->persist();
    }

    public function setVinculoHistorico($nrorg, $nrvinculom, $dtmescompetenc, $nrescalatrabm, $nrsitufuncm,
                                           $nrtpmodalidade, $contribuicaosindical, $dtbaseferias, $nrestrutsind,
                                           $idtppagamento, $idremuneracao, $nrestrutgeren, $nrestrutlegal, $nrfuncao,
                                           $nrcargo, $nrtpmovtransfm)
    {
        $this->setNrorg($nrorg);
        $this->setNrvinculom($nrvinculom);
        $this->setDtmescompetenc($dtmescompetenc);
        $this->setNrescalatrabm($nrescalatrabm);
        $this->setNrsitufuncm($nrsitufuncm);
        $this->setNrtpmodalidsal($nrtpmodalidade);
        $this->setIdcontribuisind($contribuicaosindical);
        $this->setDtbaseferias($dtbaseferias);
        $this->setNrestrutsind($nrestrutsind);

        $this->setIdtppagamento($idtppagamento);
        $this->setIdremuneracao($idremuneracao);
        $this->setNrestrutgeren($nrestrutgeren);
        $this->setNrestrutlegal($nrestrutlegal);
        $this->setNrfuncao($nrfuncao);
        $this->setNrcargo($nrcargo);
        $this->setNrtpmovtransfm($nrtpmovtransfm);
    }
}