<?php
/**
 * Created by PhpStorm.
 * User: leonardocarvalho
 * Date: 01/03/2016
 * Time: 11:41
 */

namespace HCM\Geral\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\Environment;
use HCM\Util\HCMParameters;
use HCM\Util\DateUtil;
use HCM\Util\Repositories;
use HCM\FPA\Services\ExportacaoExcelService;
use HCM\Util\FPA;
use Zeedhi\Framework\HTTP\Kernel;

class ParcnegocioService {
    
    protected $entityManager;
    /** @var Environment */
    protected $environment;
    protected $hcmParameters;

    protected $parcnegocio;

    public function __construct(EntityManager $entityManager, Environment $environment,HCMParameters $hcmParameters, ExportacaoExcelService $exportacaoExcelService, Kernel $httpKernel) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
        $this->hcmParameters   = $hcmParameters;
        $this->parcnegocio = Repositories::PARCNEGOCIO;
        $this->relacionaparc = Repositories::RELACIONAPARC;
        $this->enderecoParc = Repositories::ENDERECOPARC;
        $this->contCorrParc = Repositories::CONTCORRPARC;
        $this->exportacaoExcelService = $exportacaoExcelService;
        $this->httpKernel = $httpKernel;
    }

    public function novo($nrorg, $nmprincipalparc, $nmsecundariparc, $cdtipoparceiro, $idpessoafisica, $idinstituicao,
                         $cdtipoinscricao, $nrinscricaoparc, $dtnascifundparc)
    {
        $idativo = 'S';
        $parceiro = new $this->parcnegocio;
        $parceiro->setNrorg($nrorg);
        $parceiro->setIdativo($idativo);
        $parceiro->setNmprincipalparc($nmprincipalparc);
        $parceiro->setNmsecundariparc($nmsecundariparc);
        $parceiro->setCdtipoparcprincipal($cdtipoparceiro);
        $parceiro->setIdpessoafisica($idpessoafisica);
        $parceiro->setIdinstituicao($idinstituicao);
        $parceiro->setCdtipoinscricao($cdtipoinscricao);
        $parceiro->setNrinscricaoparc($nrinscricaoparc);
        $parceiro->setDtnascifundparc($dtnascifundparc);

        $parceiro->setDtinclusao(DateUtil::getDataAtual());
        $parceiro->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $parceiro->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $parceiro->setDtultatu(DateUtil::getDataAtual());
        $parceiro->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $parceiro->setCdoperultatu($this->hcmParameters->getCdoperador());

        $parceiro->setNrparcnegocio(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'PARCNEGOCIO', 1, 12, true));

        $this->entityManager->persist($parceiro);
        $this->entityManager->flush($parceiro); 
        //\ParceriaEntity::incluiParceria($this->nrorg, $this->parceiro->getNrparcnegocio(), $cdtipoparceiro, $idativo);

        return $parceiro;
    }

    public function novoRelacionaparc($nrorg, $nrtiporelaciona, $nrparcnegocio, $dtfimrelacionamento, $nrparcnegrelac)
    {
        $relacionaparc = new $this->relacionaparc;

        $relacionaparc->setNrorg($nrorg);
        $relacionaparc->setDtinclusao(DateUtil::getDataAtual());
        $relacionaparc->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $relacionaparc->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $relacionaparc->setDtultatu(DateUtil::getDataAtual());
        $relacionaparc->setCdoperultatu($this->hcmParameters->getCdoperador());
        $relacionaparc->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $relacionaparc->setNrparcnegocio($nrparcnegocio);
        $relacionaparc->setNrtiporelaciona($nrtiporelaciona);
        $relacionaparc->setNrparcnegrelac($nrparcnegrelac);
        //$relacionaparc->setDtfimrelacionamento($dtfimrelacionamento);
        $relacionaparc->setIdativo('S');
        $relacionaparc->setNrrelacionaparc(\HCM\Util\NovoCodigo::geraCodigo($nrorg, 'RELACIONAPARC', 1, 10, true));

        $this->entityManager->persist($relacionaparc);
        $this->entityManager->flush($relacionaparc);
        return $relacionaparc;
    }

    public function getParcnegocioVinculos($parameters, $conditions) {
        
        $OcupacaoPorComite = '';
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        $cdtipoparcprincipal = $parameters["P_CDTIPOPARCPRINCIPAL"];
        $dtmescompetenc = $this->hcmParameters->getDtCompetencia();
        
        //FitrarPorTipoComiteOcupacao
        if(isset($parameters["TIPOCOMITEOCUPACAO"])){
        $OcupacaoPorComite = 'INNER JOIN GPE_TIPOCOMITEOCUP TPO 
                    ON TPO.NROCUPACAOM = OCM.NROCUPACAOM AND TPO.NRORG = OCM.NRORG';
        }
        
        $query = $this->entityManager->getConnection()->prepare("
            SELECT * FROM (   
                SELECT
                    PARC.*,OCM.NROCUPACAOM, OCH.NMOCUPACAOH
                    FROM PARCNEGOCIO PARC
                    JOIN GPE_PESSOA PE
                        ON PE.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                        AND PE.NRORG = PARC.NRORG
                    JOIN GPE_VINCULOM VCM 
                        ON PE.NRPESSOA = VCM.NRPESSOA
                        AND PE.NRORG = VCM.NRORG
                        AND VCM.DTRESCISAOVINC IS NULL
                    JOIN GPE_VINCULOH VCH 
                        ON VCM.NRVINCULOM = VCH.NRVINCULOM
                        AND VCM.NRORG = VCH.NRORG
                        AND VCH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH VCH1
                            WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                AND VCH1.NRVINCULOM = VCH.NRVINCULOM
                                AND VCH1.NRORG = VCH.NRORG)
                    LEFT JOIN GPE_OCUPACAOM OCM 
                        ON OCM.NROCUPACAOM = NVL(VCH.NRCARGO, VCH.NRFUNCAO) 
                        AND OCM.NRORG = VCH.NRORG
                    LEFT JOIN GPE_OCUPACAOH OCH 
                        ON OCM.NROCUPACAOM = OCH.NROCUPACAOM
                        AND OCM.NRORG = OCH.NRORG
                        AND OCH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                            WHERE DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                AND NROCUPACAOM = OCH.NROCUPACAOM
                                AND NRORG = OCH.NRORG)
                    $OcupacaoPorComite            
                WHERE PARC.NRORG   = :P_NRORG
                    AND PARC.IDATIVO = 'S'
                    AND PARC.CDTIPOPARCPRINCIPAL IN ($cdtipoparcprincipal)
                    AND (:P_NMPRINCIPALPARC IS NULL OR UPPER(PARC.NMPRINCIPALPARC) LIKE UPPER(:P_NMPRINCIPALPARC))
                    AND (ROWNUM <= :P_ITEMSPERPAGE OR :P_ITEMSPERPAGE IS NULL)
                    ORDER BY NMPRINCIPALPARC)
            WHERE 1 = 1
              $conditions
        ");

        $query->execute(
            array(
                "P_NRORG"               => $nrorg,
                "P_NMPRINCIPALPARC"     => (isset($parameters["NMPRINCIPALPARC"])) ? $parameters["NMPRINCIPALPARC"] : null,
                "P_ITEMSPERPAGE"        => (isset($parameters["P_ITEMSPERPAGE"])) ? $parameters["P_ITEMSPERPAGE"] : null,
                "P_DTMESCOMPETENC" => $dtmescompetenc
            )
        );

        $tipoprocesso = $query->fetchAll();
        return $tipoprocesso;

    }
    
    public function cadAutoFormaComu($rows) {
        foreach ($rows as $row) {
            $this->novaFormacomu($row['NRPARCNEGOCIO'], $row['CDFORMACOMU'], $row['CDPREFIXCOMUPARC'], $row['CDCOMUNICAPARC'], null, null);
        }    
    }
    
    public function novaFormacomu($nrparcnegocio, $cdformacomu, $cdprefixcomuparc, $cdcomunicaparc, $cdcomplecomuparc, $nrenderecoparc) {
        $comunicaParc = Repositories::COMUNICAPARC;
        
        $obj = new $comunicaParc;
        $obj->setNrorg($this->hcmParameters->getNrorgTrabalho());
        $obj->setDtinclusao(DateUtil::getDataAtual());
        $obj->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $obj->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $obj->setDtultatu(DateUtil::getDataAtual());
        $obj->setCdoperultatu($this->hcmParameters->getCdoperador());
        $obj->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $obj->setIdativo('S');
        $obj->setNrparcnegocio($nrparcnegocio);
        $obj->setCdformacomu($cdformacomu);
        $obj->setCdprefixcomuparc($cdprefixcomuparc);
        $obj->setCdcomunicaparc($cdcomunicaparc);
        $obj->setCdcomplecomuparc($cdcomplecomuparc);
        $obj->setNrenderecoparc($nrenderecoparc);
        $nrcomunicaparc = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'COMUNICAPARC', 1, 12, true);
        $obj->setNrcomunicaparc($nrcomunicaparc);
        
        $this->entityManager->persist($obj);
        $this->entityManager->flush($obj);
    }
    
    public function novoEndereco($nrparcnegocio, $cdpais, $sgestado, $cdmunicipio, $cdlogradouro, $nmbairroendereco,
                         $cdtipoendereco, $nrcependereco, $dscompleendereco, $nrimovelendereco, $dsendereco,
                         $dsreferenciaende)
    {
        $endereco = new $this->enderecoParc;

        $endereco->setNrorg($this->hcmParameters->getNrorgTrabalho());
        $endereco->setDtinclusao(DateUtil::getDataAtual());
        $endereco->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $endereco->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $endereco->setDtultatu(DateUtil::getDataAtual());
        $endereco->setCdoperultatu($this->hcmParameters->getCdoperador());
        $endereco->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $endereco->setNrparcnegocio($nrparcnegocio);
        $endereco->setCdpais($cdpais);
        $endereco->setIdativo('S');
        $endereco->setSgestado($sgestado);
        $endereco->setCdmunicipio($cdmunicipio);
        $endereco->setCdlogradouro($cdlogradouro);
        $endereco->setNmbairroendereco($nmbairroendereco);
        $endereco->setCdtipoendereco($cdtipoendereco);
        $endereco->setNrcependereco($nrcependereco);
        $endereco->setDscompleendereco($dscompleendereco);
        $endereco->setNrimovelendereco($nrimovelendereco);
        $endereco->setDsendereco($dsendereco);
        $endereco->setDsreferenciaende($dsreferenciaende);
        $endereco->setNrenderecoparc(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'ENDERECOPARC', 1, 10, true));
        
        $this->entityManager->persist($endereco);
    }
    
    public function convertDsLogrToCdlogr($dsLogr){
        $retorno = null;
        
        if(is_string($dsLogr)) $dsLogr = strtoupper($dsLogr);
        
        // Mapa dslogradouro=>cdlogradouro.
        $map = array(        
            "RUA" => "RUA",
            "AVENIDA" => "AV",
            "PRAÇA" => "PCA",
            "PRACA" => "PCA",
            "ALAMEDA" => "AL",
            "ESTRADA" => "EST",
            "RODOVIA" => "RDV",
            "QUADRA" => "QD",
            "AEROPORTO" => "AER",
            "APARTAMENTO" => "AP",
            "BECO" => "BC",
            "BLOCO" => "BL",
            "CAMINHO" => "CAM",
            "ESCADINHA" => "ESCD",
            "FAZENDA" => "FAZ",
            "FORTALEZA" => "FORT",
            "GALERIA" => "GL",
            "QUILOMETRO" => "KM",
            "LADEIRA" => "LD",
            "LARGO" => "LGO",
            "PRAIA" => "PR",
            "QUINTA" => "QTA",
            "TRAVESSA" => "TRV",
            "VIADUTO" => "VD",
            "VILA" => "VL",
            "SUPER QUADRA" => "SQD",
            "PARQUE" => "PRQ",
            "CHÁCARA" => "CH",
            "CHACARA" => "CH",
            "CALÇADA" => "CALC",
            "CALCADA" => "CALC",
            "VIA DE ACESSO"=>"V-AC",
            "VIA" => "VIA",
            "SÍTIO" => "SIT",
            "SITIO" => "SIT",
            "ACESSO" => "AC",
            "LOTEAMENTO" => "LOT",
            "PASSAGEM" => "PSG",
            "VIELA" => "VLA",
            "FAVELA" => "FAV",
            "FEIRA" => "FRA",
            "JARDIM" => "JD",
            "LAGO" => "LG",
            "LAGOA" => "LGA",
            "MORRO" => "MRO",
            "TRECHO" => "TR",
            "VALE" => "VLE",
            "VEREDA" => "VER",
            "ACAMPANHAMENTO" => "0003",
            "AREA" => "A",
            "ÁREA" => "A",
            "CAMPO" => "CPO",
            "COLÔNIA" => "COL",
            "COLONIA" => "COL",
            "CONDOMÍNIO" => "CON",
            "CONDOMINIO" => "CON",
            "CONJUNTO" => "CJ",
            "DISTRITO" => "DT",
            "ESPLANADA" => "ESP",
            "NÚCLEO" => "NUC",
            "NUCLEO" => "NUC",
            "OUTROS" => "O",
            "PASSARELA" => "PSA",
            "PÁTIO" => "PAT",
            "PATIO" => "PAT",
            "RECANTO" => "REC",
            "RESIDENCIAL" => "RES",
            "SETOR" => "ROD",
            "ACAMPAMENTO" => "0004",
        );
        
        if(isset($map[$dsLogr]) && !empty($map[$dsLogr])) $retorno = $map[$dsLogr];
        
        return $retorno;

    }
    
    public function importarPlanilhaContaCorrente($row) {
        $nrorg       = $this->hcmParameters->getNrorgTrabalho();
        $nrorgPadrao = $this->hcmParameters->getNrorgPadrao();
        $messages    = array(); 
                $dados = $this->getDadosCantaCorrente($row['DSPATH'][0]);
        foreach($dados as $lin => $dado) {
            $res = $this->insereContaCorrente($lin + 2, $nrorg, $nrorgPadrao,
                $dado['NRVINCULOM'], $dado['NMPESSOA'], $dado['CDBANCO'],
                $dado['CDAGENCIA'], $dado['CTCORRENTE'], $dado['TPCONTA']);
            foreach($res as $msg)
                $messages[] = $msg;
        }
        return $messages;
    }
    
    public function getDadosCantaCorrente($path) {
        $head = array(
            'NRVINCULOM',
            'NMPESSOA',
            'CDBANCO',
            'CDAGENCIA',
            'CTCORRENTE',
            'TPCONTA'
            );
        
        $file = $this->httpKernel->factoryFromFileData($path, FPA::getTempDirectory()."/");
        $caminhoNovo = DIRECTORY_SEPARATOR . $file->getPathname();
        
        $file = \PHPExcel_IOFactory::load($caminhoNovo);
        $file->setActiveSheetIndex(0);

        return $this->exportacaoExcelService->preparaInfo_generic($file, $head, 'NRVINCULOM');
    }
    
    public function insereContaCorrente($nrRow, $nrorg, $nrorgPadrao, $nrvinculom, $nmpessoa, $cdbanco, $cdagencia, $cdcontcorr, $nrtpcontcorr) {
        $msg = array();
        
        try {
            //Aquisição de dados (nrpessoa e nrparcnegocio) e validações
            $objVinculom = $this->entityManager->getRepository(Repositories::GPE_VINCULOM)->findOneBy(
                array('nrorg' => $nrorg, 'nrvinculom' => $nrvinculom));
            if($objVinculom == null) {
                $msg[] = array("msg" => "Vínculo '$nrvinculom' não encontrado na linha $nrRow.");
            } else {
                $objPessoa = $this->entityManager->getRepository(Repositories::GPE_PESSOA)->findOneBy(
                    array('nrorg' => $nrorg, 'nrpessoa' => $objVinculom->getNrpessoa()));
                if($objPessoa == null) {
                    $msg[] = array("msg" => "A pessoa do vínculo '$nrvinculom' não foi encontrada. Linha $nrRow.");
                } else {
                    $nrparcnegocio = $objPessoa->getNrparcnegocio();
                }
            }
            //Banco
            if(!is_numeric($cdbanco))
                $msg[] = array("msg" => "Código do banco ($cdbanco) deve ser numérico. Linha $nrRow.");
            else {
                $cdbanco = str_pad($cdbanco, 3, '0', STR_PAD_LEFT);
                $objBanco = $this->entityManager->getRepository(Repositories::BANCO)->findOneBy(
                    array('cdbanco' => $cdbanco));
                if($objBanco == null)
                    $msg[] = array("msg" => "Código do banco ($cdbanco) inválido na linha $nrRow.");
            }
            //Agência
            if(!is_numeric($cdagencia))
                $msg[] = array("msg" => "Código da agência ($cdagencia) deve ser numérico. Linha $nrRow.");
            //Conta corrente
            if($cdcontcorr == null)
                $msg[] = array("msg" => "O número da conta deve ser informado. Linha $nrRow.");
            else if(!is_numeric($cdcontcorr))
                $msg[] = array("msg" => "O número da conta ($cdcontcorr) deve ter somente números. Linha $nrRow.");
            if(strlen($cdcontcorr) > 20)
                $msg[] = array("msg" => "O número da conta ($cdcontcorr) deve ter no máxmo 20 caracteres. Linha $nrRow.");
            //Tipo de conta
            if($nrtpcontcorr == null) //Valor default
                $nrtpcontcorr = '2';
            if(!in_array($nrtpcontcorr, array("1", "2", "3", "4")))
                $msg[] = array("msg" => "Tipo de conta ($nrtpcontcorr) inválido na linha $nrRow. Permitido: 1 C. Moviment.; 2 CNAB; 3 C. Salário; 4 Pensão Judicial.");
            
            //Verificação de registro ká existente e Inserção
            if(count($msg) == 0) { //Apenas se não houver erros
                $objContcorrparc = $this->entityManager->getRepository(Repositories::CONTCORRPARC)->findOneBy(
                    array('nrorg' => $nrorg, 'nrparcnegocio' => $nrparcnegocio, 'cdbanco' => $cdbanco, 'idativo' => 'S'));
                if($objContcorrparc == null) {
                    $this->novoContaCorrente($nrparcnegocio, null, $cdbanco, $cdagencia, $cdcontcorr, $nrtpcontcorr);
                    $this->entityManager->flush();
                } else
                    $msg[] = array("msg" => "O vínculo $nrvinculom já possui uma conta bancária no banco $cdbanco. Registro não inserido. Linha $nrRow.");
            }
        } catch (\Exception $e) {
            throw $e;
        }
        return $msg;
    }
    
    public function novoContaCorrente($nrparcnegocio, $cdreducont, $cdbanco,
                     $cdagencia, $cdcontcorr, $nrtpcontcorr)
    {
        $contaCorr = new $this->contCorrParc;
        $contaCorr->setNrorg($this->hcmParameters->getNrorgTrabalho());
        $contaCorr->setDtinclusao(DateUtil::getDataAtual());
        $contaCorr->setCdoperinclusao($this->hcmParameters->getCdoperador());
        $contaCorr->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
        $contaCorr->setDtultatu(DateUtil::getDataAtual());
        $contaCorr->setCdoperultatu($this->hcmParameters->getCdoperador());
        $contaCorr->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
        $contaCorr->setIdativo('S');
        $contaCorr->setNrparcnegocio($nrparcnegocio);
        $contaCorr->setCdreducont($cdreducont);
        $contaCorr->setCdbanco($cdbanco);
        $contaCorr->setCdagencia($cdagencia);
        $contaCorr->setCdcontcorr($cdcontcorr);
        $contaCorr->setNrtpcontcorr($nrtpcontcorr);
        $contaCorr->setNrcontcorrparc(\HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), 'CONTCORRPARC', 1, 10, true));
        $this->entityManager->persist($contaCorr);
    }
    
    public function defineBairro($endereco) {
        if ($endereco->getCdbairro() !== null) {
            $bairro = $this->entityManager->getRepository(Repositories::BAIRRO)->findBy(array('cdpais' => $endereco->getCdpais(),
            'sgestado' => $endereco->getSgestado(),'cdmunicipio'=> $endereco->getCdmunicipio(),'cdbairro'=> $endereco->getCdbairro()));
            return $bairro->getNmbairro();
        } else {
            return $endereco->getNmbairroendereco();
        }
    }
    
}