<?php

namespace HCM\TRE\Controllers;

use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use HCM\Util\HCMParameters;
use HCM\Util\Util;
use HCM\TRE\Services\CustomizavelTreService;

class CustomizavelTreController extends Crud {

    protected $dataSourceName = 'getCustomizavelTre';
    protected $dataSourceName_conteudoCurso = 'getCustomizavelTre_conteudoCurso';
    
    protected $parameterBagColumns = array('P_NRORG', 'P_NRORG_PADRAO','P_DTMESCOMPETENC');
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, HCMParameters $hcmParameters, CustomizavelTreService $customizavelTreService){
        $this->parameterBag = $parameterBag;
        $this->hcmParameters = $hcmParameters;
        $this->customizavelTreService = $customizavelTreService;
        parent::__construct($dataSourceManager);
    }

    public function getCustomizavel(DTO\Request\Filter $request, DTO\Response $response) {
        $filterData = $request->getFilterCriteria();
        
        $idexibirconteudocurso = null;
        $conditions = $buttonFloatingSearch = [];

        foreach($filterData->getConditions() as $condition) {
            if ($condition['columnName'] == 'IDEXIBIRCONTEUDOCURSO') {
                $idexibirconteudocurso = $condition['value'];
            }elseif ($condition['operator'] === '=') {
                $conditions[] = $condition['columnName'] . " " . $condition['operator'] . " '" . $condition['value']."' ";
            } elseif ($condition['operator'] === 'BETWEEN') {
                $conditions[] = $condition['columnName'] . " " . $condition['operator'] . " '" . $condition['value'][0] . "' AND '" . $condition['value'][1] . "'";
            }elseif ($condition['operator'] === 'LIKE_ALL' || $condition['operator'] === 'LIKE_I'){
                $buttonFloatingSearch[] = $condition;
            }
        }
        
        $buttonFloatingSearch = Util::createQueryFiltered($buttonFloatingSearch);
        
        $dataSet = $this->customizavelTreService->getRelatCustomizavel($idexibirconteudocurso, $conditions, $buttonFloatingSearch);

        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('getCustomizavelTre', $dataSet));
    }
    
    protected function processConditionValue($condition) {
        return $condition['value'];
    }
    protected function populateParameterBag(FilterCriteria $filterCriteria) {

        $conditions = array();
        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $this->parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }
        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );
        return $newFilterCriteria;
    }
} 