<?php

namespace Folha\Logic\EscalaTrabalho;
/**
 * Description of EscalaTrabalho
 *
 * @author carinaoliveira
 */

use Folha\Entities\GpeEscalatrabh;
use Folha\Entities\GpeEscalatrabm;
use Folha\Entities\GpeHorarioturno;
use Folha\Entities\GpeTurno;
use Setforms2\Runtime\Connection;
use Setforms2\Shared\Registry;

class EscalaTrabalho {
        
        //Função que insere na tabela GPE_ESCALATRABH os campos que nao estao na tabela GPE_ESCALATRABM
	public static function insereEscalaTrabH($campos)
	{
            $db = Connection::getInstance();
            $db->getConn()->beginTransaction();
            $connection = Registry::getEntityManager();

            try{            
                $escalatrabh = new GpeEscalatrabh();
                $escalatrabh->setCdoperultatu($campos['CDOPER']);
                $escalatrabh->setSegentrada($campos['SEGENTRADA']);
                $escalatrabh->setDtultatu($campos['DTINCLUSAO']);
                $escalatrabh->setQthrsemesctrabh($campos['QTHRSSEMESCTRABH']);
                $escalatrabh->setPrisaida($campos['PRIMSAIDA']);
                $escalatrabh->setNmescalatrabh($campos['NMESCALAH']);
                $escalatrabh->setDescansosemanal($campos['DESCANSOSEM']);
                $escalatrabh->setSegsaida($campos['SEGSAIDA']);
                $escalatrabh->setPrientrada($campos['PRIMENTRADA']);
                $escalatrabh->setCdoperinclusao($campos['CDOPER']);
                $escalatrabh->setNrorginclusao($campos['NRORG']);
                $escalatrabh->setNrorgultatu($campos['NRORG']);
                $escalatrabh->setQthrescalatrabh($campos['QTHRSESCTRABH']);
                $escalatrabh->setNrescalatrabm($campos['NRESCALATRABM']);
                $escalatrabh->setNrorg($campos['NRORG']);
                $escalatrabh->setDtinclusao($campos['DTINCLUSAO']);
                $escalatrabh->setDtmescompetenc($campos['DTMESCOMPT']);
                $escalatrabh->setNrescalatrabh($campos['NRESCALATRABH']);
                $escalatrabh->setNrdiasapurvales($campos['NRDIASAPURVALES']);
                $escalatrabh->setNrtpjornada($campos['NRTPJORNADA']);
                $escalatrabh->setNrtpintervalo($campos['NRTPINTERVALO']);

                $escalatrabh->persist();

                $connection->flush();

                $db->getConn()->commit();     

            }catch(\Exception $e){
                $db->getConn()->rollback();
                throw $e;
            }
	}  
        
	public static function insereEscalaTrabM($campos)
	{
            $db = Connection::getInstance();
            $db->getConn()->beginTransaction();
            $connection = Registry::getEntityManager();

            try{            
                $escalatrabm = new GpeEscalatrabm();
                $escalatrabm->setCdoperultatu($campos['CDOPER']);
                $escalatrabm->setDtultatu($campos['DTINCLUSAO']);
                $escalatrabm->setCdoperinclusao($campos['CDOPER']);
                $escalatrabm->setNrorginclusao($campos['NRORG']);
                $escalatrabm->setNrorgultatu($campos['NRORG']);
                
                if (!(is_null($campos['DTINIVIGENCIA']) || $campos['DTINIVIGENCIA'] == '')) {
                    $escalatrabm->setDtinivigencia($campos['DTINIVIGENCIA']);
                }
                if (!(is_null($campos['DTFIMVIGENCIA']) || $campos['DTFIMVIGENCIA'] == '')) {
                    $escalatrabm->setDtfimvigencia($campos['DTFIMVIGENCIA']);
                }
                
                $escalatrabm->setNrescalatrabm($campos['NRESCALATRABM']);
                $escalatrabm->setNrorg($campos['NRORG']);
                $escalatrabm->setDtinclusao($campos['DTINCLUSAO']);

                $escalatrabm->persist();

                $connection->flush();

                $db->getConn()->commit();     

            }catch(\Exception $e){
                $db->getConn()->rollback();
                throw $e;
            }
	}  
                       
        public static function atualizaOuInsereCamposEscalaTrabH($campos) {
            $escalastrabh = GpeEscalatrabh::findOneByNrorgAndNrescalatrabmAndDtmescompetenc(
                $campos['NRORG'], $campos['NRESCALATRABM'], $campos['DTMESCOMPT']
            );            
            

            if(!$escalastrabh){
                $campos['NRESCALATRABH'] = \Geral\Util\NovoCodigo::geraCodigo(\Geral\Util\Ambiente::getNrorg(), 'GPE_ESCALATRABH', 1, 10, true);
                $escalastrabh = new GpeEscalatrabh();
                $escalastrabh->setCdoperinclusao($campos['CDOPER']);
                $escalastrabh->setNrorginclusao($campos['NRORG']);
                $escalastrabh->setNrescalatrabm($campos['NRESCALATRABM']);
                $escalastrabh->setNrorg($campos['NRORG']);
                $escalastrabh->setDtinclusao($campos['DTINCLUSAO']);
                $escalastrabh->setDtmescompetenc($campos['DTMESCOMPT']);
                $escalastrabh->setNrescalatrabh($campos['NRESCALATRABH']);
            }

            $escalastrabh->setDescansosemanal($campos['DESCANSOSEM']);
            $escalastrabh->setNmescalatrabh($campos['NMESCALAH']);
            $escalastrabh->setQthrescalatrabh($campos['QTHRSESCTRABH']);
            $escalastrabh->setQthrsemesctrabh($campos['QTHRSSEMESCTRABH']);
            $escalastrabh->setPrientrada($campos['PRIMENTRADA']);
            $escalastrabh->setPrisaida($campos['PRIMSAIDA']);
            $escalastrabh->setNrdiasapurvales($campos['NRDIASAPURVALES']);
            $escalastrabh->setSegentrada($campos['SEGENTRADA']);
            $escalastrabh->setSegsaida($campos['SEGSAIDA']);
            $escalastrabh->setNrorgultatu($campos['NRORG']);
            $escalastrabh->setDtultatu($campos['DTALTERACAO']);                
            $escalastrabh->setCdoperultatu($campos['CDOPER']);
            $escalastrabh->setNrtpjornada($campos['NRTPJORNADA']);
            $escalastrabh->setNrtpintervalo($campos['NRTPINTERVALO']);
            
            try{    
                $db = Connection::getInstance();
                $db->getConn()->beginTransaction();
                $connection = Registry::getEntityManager();

                $escalastrabh->persist();

                $connection->flush();

                $db->getConn()->commit();     
            }catch(\Exception $e){
                $db->getConn()->rollback();
                throw $e;
            }            
        }
        
        public static function atualizaCamposEscalaTrabM($campos) {
            $db = Connection::getInstance();
            $db->getConn()->beginTransaction();
            $connection = Registry::getEntityManager();
            $escalatrabm = GpeEscalatrabm::findOneByNrorgAndNrescalatrabm($campos['NRORG'], $campos['NRESCALATRABM']);
            
            try{    
                $escalatrabm->setDtinivigencia($campos['DTINIVIGENCIA']);
                $escalatrabm->setDtfimvigencia($campos['DTFIMVIGENCIA']);
                $escalatrabm->setNrorgultatu($campos['NRORG']);
                $escalatrabm->setDtultatu($campos['DTALTERACAO']);                
                $escalatrabm->setCdoperultatu($campos['CDOPER']);
                  
                $escalatrabm->persist();

                $connection->flush();

                $db->getConn()->commit();     

            }catch(\Exception $e){
                $db->getConn()->rollback();
                throw $e;
            }
            
        }
        
        //Validar a exclusão da escala.
	public static function deleteEscala($nrOrg, $nrescalatrabm) {
            $db = Connection::getInstance();
            $db->getConn()->beginTransaction();
            $manager = Registry::getEntityManager();  
        
            try{
                //Exclui primeiro os registros necessários que podem estar associados.
                self::deleteHistorico($nrOrg, $nrescalatrabm);
                self::deleteTurno($nrOrg, $nrescalatrabm);
                             
                $manager->flush();
        
                $db->getConn()->commit();            
            }catch(\Exception $e){
                $db->getConn()->rollback();
                throw $e;
            }
	}
        
        public static function deleteHistorico($nrOrg, $nrescalatrabm)
        {
            $manager     = Registry::getEntityManager();  
            $escalaTrabH = GpeEscalatrabh::findByNrorgAndNrescalatrabm($nrOrg, $nrescalatrabm);
                
            foreach($escalaTrabH as $escala) {
                $escala->delete();
            }
                             
            $manager->flush();
        }
        
        public static function deleteTurno($nrOrg, $nrescalatrabm)
        {
            $manager  = Registry::getEntityManager(); 
            $gpeTurno = GpeTurno::findByNrorgAndNrescalatrabm($nrOrg, $nrescalatrabm);
            
             foreach($gpeTurno as $turno) {
                 self::deleteHorario($nrOrg, $turno->getNrturno());
                 $turno->delete();
             }
                             
             $manager->flush();
        }
        
        public static function deleteHorario($nrOrg, $nrTurno)
        {
            $manager    = Registry::getEntityManager(); 
            $gpeHorario = GpeHorarioturno::findByNrorgAndNrturno($nrOrg, $nrTurno);
            
            foreach($gpeHorario as $horario) {                
                $horario->delete();
            }
                             
            $manager->flush();
        }
}