<?php
namespace Geral\Entities;

/**
 * @method Tipooperac findByNrorgAndCodigoAndIdOperacao static
 * @method \Geral\Repositories\Tipooperac getRepository static
 * @method \Geral\Entities\Tipooperac findOneByIdentrsaidopAndCdtipooperAndNrorg($identrsaidop, $cdoperac, $nrorg) static
 */
class Tipooperac extends Base\Tipooperac
{

    /**
     * Define operacoes de entrada.
     */
    const OPERACAO_ENTRADA = "E";
    /**
     * Define operacoes de saida.
     */
    const OPERACAO_SAIDA   = "S";

    /**
     * Autoriza a atualizacao de estoque.
     */
    const AUTORIZA_ATUALIZACAO_ESTOQUE     = "S";
    /**
     * Nao autoriza atualizacao de estoque.
     */
    const NAO_AUTORIZA_ATUALIZACAO_ESTOQUE = "N";

    /**
     * Considera tipo de conta para geração de rateio contábil
     */
    const IDCONSCTBRAT_SIM = "S";
    /**
     * Nao considera tipo de conta para geração de rateio contábil
     */
    const IDCONSCTBRAT_NAO = "N";
    /**
     * Utiliza vencimento
     * IDUTILVENC := "S"
     */
    const UTILIZA_VENCIMENTO = "S";
    /**
     * Não utiliza vencimento
     * IDUTILVENC := "N"
     */
    const NAO_UTILIZA_VENCIMENTO = "N";
    /**
     * Utiliza vencimento cobrança
     * IDUTILVENCOBR := "S"
     */
    const UTILIZA_VENCIMENTO_COBRANCA = "S";
    /**
     * Não utiliza vencimento
     * IDUTILVENCOBR := "N"
     */
    const NAO_UTILIZA_VENCIMENTO_COBRANCA = "N";
    /**
     * Gera vencimentos
     * IDGERAVENC := "S"
     */
    const GERA_VENCIMENTO = "S";
    /**
     * Não gera vencimentos
     * IDGERAVENC := "N"
     */
    const NAO_GERA_VENCIMENTO = "N";


    /**
     * Verifica se o sistema está parametrizado para permitir que se faca atualizacao de estoque automatica. Por
     * padrao, o tipo de operacao a ser validado sera operacoes de entrada.
     *
     * @param string $operacao
     * @return bool
     */
    public function permiteAtualizacaoDeEstoque($operacao = self::OPERACAO_ENTRADA)
    {
        return $this->getIdatuesttpop() === self::AUTORIZA_ATUALIZACAO_ESTOQUE &&
            $this->getIdentrsaidop() === $operacao;
    }

}