<?php

namespace Geral\Exceptions;
/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 11/01/13
 * Time: 14:25
 * To change this template use File | Settings | File Templates.
 */
class ExcecoesData extends \Geral\Logic\Exception
{

    private $messageName;

    /**
     * Construtor.
     *
     * Recebe o nome da mensagem cadastrada no setforms.
     *
     * @param string $messageName
     * @param string $message
     * @param int $code
     * @param \Exception|null $previous
     */
    public function __construct($messageName, $message = "", $code = 0, \Exception $previous = null)
    {
        parent::__construct($message, $code, $previous);
        $this->messageName = $messageName;
    }

    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName()
    {
        return $this->messageName;
    }

    /**
     * @static
     * @throws ExcecoesData
     */
    public static function informarData()
    {
        throw new self (
            'msg_informar_data',
            'Informe a data.'
        );
    }

    /**
     * @static
     * @throws ExcecoesData
     */
    public static function dataFinalMenorQueDataInicial()
    {
        throw new self (
            'msg_valida_dataInicialFinal',
            'A data final deve ser maior que a data inicial.'
        );
    }

    /**
     * @param $data
     * @throws ExcecoesData
     */
    public static function dataFinalMaiorQuePermitido($data)
    {
        $ex = new self('msg_datafinal_maior_que_permitido'); // Data final deve ser menor ou igual a %1.
        $ex->setParams(array($data));
        throw $ex;
    }

    /**
     * @static
     * @throws ExcecoesData
     */
    public static function datasEntreMeses()
    {
        throw new self (
            'msg_pla00118_mesFinalDiferentemesInicial',
            'O mês final não pode ser diferente dos inicial.'
        );
    }

}
